; clabel charmap generator

(define (addchar im char offset yoffset mapfile fontsize font)
  (if (< char 127)
      (let* ((tlay (car (gimp-text-layer-new im (string (integer->char char)) font fontsize 0)))
	     (cwidth (car (gimp-drawable-width tlay)))
	     (descent (cadddr (gimp-text-get-extents-fontname (string (integer->char 32)) fontsize 0 font)))) 
	
	(gimp-image-add-layer im tlay 0)
	(gimp-text-layer-set-color tlay '(255 255 255))
	(gimp-text-layer-set-letter-spacing tlay 0)
	(gimp-text-layer-set-line-spacing tlay 0)
	(gimp-text-layer-set-justification tlay 3)
	
	(gimp-layer-resize tlay cwidth fontsize 0 descent)
	(gimp-layer-set-offsets tlay offset yoffset)
	(gimp-image-merge-visible-layers im 0)
	(gimp-image-resize-to-layers im)

	(display (string-append ",{" (number->string offset) "," (number->string cwidth) "}") mapfile)
	(addchar im (+ char 1) (+ offset cwidth) yoffset mapfile fontsize font))))

(define (addline im sizes yoffset mapfile font adj)
  (let* ((fontsize (car sizes))
	 (adjfontsize (- fontsize adj))
	 (offset (car (gimp-text-get-extents-fontname (string (integer->char 32)) adjfontsize 0 font))))
    
    (display (string-append "[" (number->string fontsize) "] = { offset=" (number->string yoffset) ", {0," (number->string offset) "}") mapfile)
    
    (addchar im 33 offset yoffset mapfile adjfontsize font)
    (display (string-append "}" (if (> (length sizes) 1) "," "")) mapfile)

    (if (> (length sizes) 1)
	(addline im (cdr sizes) (+ fontsize yoffset) mapfile font adj)))
)

(define (ven-charmap font adj)
  (let* ((im (car (gimp-image-new 10 10 0)))
	 (lay (car (gimp-layer-new im 10 10 0 "x" 0 0)))
	 (mapfile (open-output-file "charmap.lua")))
    
    (gimp-image-add-layer im lay 0)
    (gimp-drawable-fill lay 2)
    
    (display (string-append "return {" "") mapfile)
    (addline im '(10 15 20) 0 mapfile font adj)
    
    (display (string-append ", width=" (number->string (car (gimp-image-width im)))) mapfile)
    (display (string-append ", height=" (number->string (car (gimp-image-height im)))) mapfile)

    (display "}" mapfile)

    (close-output-port mapfile)
    (file-png-save-defaults 1 im (car (gimp-image-get-active-drawable im)) "charmap.png" "charmap.png")
    (gimp-display-new im)))

(script-fu-register "ven-charmap" 
		    _"<Image>/Filters/Vendetta/charmap"
                    "ven-charmap"
                    ""
                    ""
                    ""
                    "RGBA GRAYA"
		    SF-FONT "Font" "Sans"
		    SF-ADJUSTMENT "Font Adjust" '(0 -5 5 1 1 0 0))
