-- custom label

local clabel = {}
local map = dofile("charmap.lua")
	
function clabel.new() 

	local fontsize = 0
	
	local label = iup.hbox{fgcolor="10 0 0 100"}
	label.chars = {}
	
	label.color = "255 255 255"

	function label:setfont(font)
		local idx = 0
		for i,v in pairs(map) do
			if tonumber(i) and i > idx and i <= font then
				idx = i
			end
		end
		fontsize = idx
	end

	function label:set(str, size)
		self.chars = {}
		local child = iup.GetNextChild(self)
		while child do
			local bro = iup.GetBrother(child)
			iup.Destroy(child)
			child = bro
		end

		local offset = 0
		local i = 1
		while i <= #str do
			local char = str:sub(i,i):byte()
			if char == 127 then
				local hexcolor = str:sub(i + 1, i + 6)
				if hexcolor:match("%x%x%x%x%x%x") then
					self.color = hextorgb(hexcolor)
					i = i + 6
				end
			else

				if char < 32 or char > 126 then
					char = 32
				end
				char = char - 31
				
				local row = map[fontsize]
				local coords = row[char]
				
				local coff = coords[1]
				local cwidth = coords[2]
				
				local x1 = coff / map.width
				local y1 = row.offset / map.height
				local x2 = (coff + cwidth) / map.width
				local y2 = (row.offset + fontsize) / map.height
				
				local c = iup.label{title="", image="plugins/clabel/charmap.png", UV=tostring(x1).." "..tostring(y1).." "..tostring(x2).." "..tostring(y2).." ", size=tostring(cwidth).."x"..fontsize}
				
				self.chars[c] = true
				c.fgcolor = self.color
				iup.Append(self, c)
				
				offset = offset + cwidth
			end
			i = i + 1
		end

		self.size = tostring(offset).."x"..fontsize
		iup.Refresh(iup.GetParent(self))
	end

	return label 
end

return clabel